//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "frmColorSelView.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "CGRID"
#pragma link "CSPIN"
#pragma resource "*.dfm"

TciColorSelView *ciColorSelView;


int Mix[] = {clBlack,   //¦
             clMaroon,  //t
             clGreen,   //`
             clOlive,   //V
             clNavy,    //`Ŧ
             clPurple,  //
             clTeal,    //`C
             clGray,    //Ǧ
             clLtGray,  //LǦ
             clRed,     //
             clLime,    //
             clYellow,  //
             clBlue,    //Ŧ
             clFuchsia, //
             clAqua,    //C
             clWhite    //զ
            };

//---------------------------------------------------------------------------
__fastcall TciColorSelView::TciColorSelView(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TciColorSelView::FormShow(TObject *Sender)
{
   m_SelColor = clBlack;
//   CreateMixToImageList(lsColorImg);
   CreateMixImages();
//   setColorToMix();
}
//---------------------------------------------------------------------------
void TciColorSelView::CreateMixToImageList(TImageList *ls)
{
  for (int i=0; i < sizeof(Mix)/sizeof(int); i++)
  {
     Graphics::TBitmap *shp = new Graphics::TBitmap();

     shp->Width = 16;
     shp->Height = 16;

     shp->Canvas->Brush->Color = (TColor)Mix[i];
     shp->Canvas->FillRect(TRect(0,0,16,16));    //񺡰ϰ
     shp->Canvas->Pen->Color = clBlack;
     shp->Canvas->Rectangle(TRect(0,0,16,16));   //e

     ls->Add(shp, NULL);
  }
}
//---------------------------------------------------------------------------
void TciColorSelView::CreateSelColorToImageList(int index, TImageList *ls)
{
   if (index >=0 && index < ls->Count)
      ls->Delete(index);

   Graphics::TBitmap *shp = new Graphics::TBitmap();

   shp->Width = 16;
   shp->Height = 16;

   shp->Canvas->Brush->Color = m_SelColor;
   shp->Canvas->FillRect(TRect(0,0,16,16));    //񺡰ϰ
   shp->Canvas->Pen->Color = clBlack;
   shp->Canvas->Rectangle(TRect(0,0,16,16));   //e

   ls->Insert(index, shp, NULL);
}
//---------------------------------------------------------------------------
void TciColorSelView::CreateMixImages()
{
   int x = 0, y = 0;
   for (int i=0; i < sizeof(Mix)/sizeof(int); i++)
   {
      if (x > 5)
      {
         y++;
         x = 0;
      }
      m_img[x][y] = new TImage(this);

      m_img[x][y]->Width = 16;
      m_img[x][y]->Height = 16;
      m_img[x][y]->Top = 10 + y*18;
      m_img[x][y]->Left = 10 + x*18;
      m_img[x][y]->OnClick = OnColorImageClick;
      m_img[x][y]->Parent = this;

      m_img[x][y]->Canvas->Brush->Color = (TColor)Mix[i];
      m_img[x][y]->Canvas->FillRect(TRect(0,0,16,16));    //񺡰ϰ
      m_img[x][y]->Canvas->Pen->Color = clBlack;
      m_img[x][y]->Canvas->Rectangle(TRect(0,0,16,16));   //e
      x++;
   }

   btnColorSet = new TButton(this);
   btnColorSet->Top = 12 + (y+1)*18;
   btnColorSet->Left = 10;
   btnColorSet->Width = 6*18;
   btnColorSet->Height = 22;
   btnColorSet->Caption = "Lm";
   btnColorSet->OnClick = OnColorSetClick;
   btnColorSet->Parent = this;

   this->Width = 12*2 + btnColorSet->Width;
   this->Height = 12 + btnColorSet->Height + 5*18;
}
//---------------------------------------------------------------------------
void __fastcall TciColorSelView::OnColorImageClick(TObject *Sender)
{
   TImage *img;

   img = dynamic_cast<TImage *>(Sender);
   if (!img) return;

   m_SelColor = img->Canvas->Brush->Color;
   this->ModalResult = mrOk;
}
//---------------------------------------------------------------------------
void __fastcall TciColorSelView::OnColorSetClick(TObject *Sender)
{
   if (ColorDialog1->Execute())
   {
      m_SelColor = ColorDialog1->Color;
      this->ModalResult = mrOk;
   }
}
//---------------------------------------------------------------------------
void TciColorSelView::setColorToMix()
{
   Graphics::TBitmap *shp = new Graphics::TBitmap();
   for (int y =0; y < 3; y++)
   {
      for (int x =0; x < 6; x++)
      {
         lsColorImg->GetBitmap((x+1)*(y+1)-1, shp);
         m_img[x][y]->Canvas->Handle = shp->Canvas->Handle;
         m_img[x][y]->Repaint();
      }
   }
   this->Repaint();
}
//---------------------------------------------------------------------------
TColor TciColorSelView::getSelColor()
{
   return m_SelColor;
}
//---------------------------------------------------------------------------



