//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "frmMain.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TciMain *ciMain;
//---------------------------------------------------------------------------
__fastcall TciMain::TciMain(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TciMain::FormCreate(TObject *Sender)
{//
   m_view = new TView();
   m_evm = new TEnvironment();

   m_nSaveHeight = 0;
}
//---------------------------------------------------------------------------
void __fastcall TciMain::FormShow(TObject *Sender)
{
   m_view->LoadFilesFromFile();
   if (m_view->Count<=0)
      m_view->ScanDirectoryFiles();

   Init();

   setPicAndDocRatio();
   LoadPicDocFile();
   LoadDocFile(); // Ĥ@Doc~,bs
}
//---------------------------------------------------------------------------
void __fastcall TciMain::FormClose(TObject *Sender, TCloseAction &Action)
{
   if (m_evm->getSaveIndex())
      m_evm->setSavePicIndex(m_view->getPoint());
   m_evm->setFormTop(Top);
   m_evm->setFormLeft(Left);
   m_evm->setFormHeight(Height);
   m_evm->setFormWidth(Width);
   //m_evm->setSplitterTop(Splitter1->Top);
   m_evm->setPreviewHeight(pbPreview->Height);
   m_evm->setDocVisible(Panel1->Visible);
   m_evm->setScanPath(m_view->getScanDirectory());
}
//---------------------------------------------------------------------------
void __fastcall TciMain::FormDestroy(TObject *Sender)
{
   delete m_evm;
   delete m_view;
}
//---------------------------------------------------------------------------
void TciMain::Init()
{
   cboFont->Items = Screen->Fonts;
   cboFont->Text = "Time New Roman";
   cboSize->Text = 12;
   dtpDate->DateTime = Now();
   m_SelColor = clBlack;
   ppmSlideShow->Checked = tbnSlideShow->Down;

   Top = m_evm->getFormTop();
   Left = m_evm->getFormLeft();
   Height = m_evm->getFormHeight();
   Width = m_evm->getFormWidth();
   pbPreview->Height = m_evm->getPreviewHeight();
   Panel1->Visible = m_evm->getDocVisible();
   //Splitter1->Top = m_evm->getSplitterTop();

   if (m_evm->getSaveIndex())
      m_view->setPoint(m_evm->getSavePicIndex());
   else
      m_view->setPoint(0);

   m_view->setRepeat(m_evm->getRepeat());
   m_view->setScanDirectory(m_evm->getScanPath());
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
// Get Current file name
//---------------------------------------------------------------------------
AnsiString TciMain::getCurrentPicFile()
{
   return m_view->getFilePath()+m_view->getPicName();
}
//---------------------------------------------------------------------------
AnsiString TciMain::getCurrentDocFile()
{
   return m_view->getFilePath()+m_view->getDocName();
}
//---------------------------------------------------------------------------

void TciMain::LoadPicDocFile()
{
   LoadImage();
   LoadDocFile();
   ViewInfo();
}
//---------------------------------------------------------------------------
// ϧɸJAܦbAm
//---------------------------------------------------------------------------
void TciMain::LoadImage()
{
   Image->Picture = NULL;
   if (m_view->Count == 0) return;

   AnsiString file= getCurrentPicFile();

   if (!FileExists(file)) { ShowMsg("Not Exists"); return; }

   Image->AutoSize = true;
   Image->Picture->LoadFromFile(file);
   m_view->setImgHeight(Image->Height);
   m_view->setImgWidth(Image->Width);

   UpdatePreviewImage();
}
//---------------------------------------------------------------------------
void TciMain::UpdatePreviewImage()
{
   double wRatio, hRatio;
   int aWidth, aHeight;

   Image->AutoSize = false;

   // resize the image
   if(Image->Width > pbPreview->Width ||
      Image->Height > pbPreview->Height)
   {
      if (pbPreview->Height<=0) pbPreview->Height = Height/2;
      if (pbPreview->Width<=0) pbPreview->Width = Width/2;

      wRatio = (double)(Image->Width) / pbPreview->Width;
      hRatio = (double)Image->Height / pbPreview->Height;

      if(wRatio > hRatio)
      {
         aWidth = pbPreview->Width;
         aHeight =  Image->Height / wRatio;
      }
      else
      {
       	 aWidth = Image->Width / hRatio;
         aHeight = pbPreview->Height;
      }
   }
   else
   {
      aWidth = Image->Width;
      aHeight = Image->Height;
   }
   // NXjpJImage
   Image->Left = (pbPreview->Width - aWidth) / 2;
   Image->Top = (pbPreview->Height - aHeight) / 2;
   Image->Width = aWidth;
   Image->Height = aHeight;
   double r = m_view->getImgRatio(aHeight, aWidth)*100;
   m_zPicRatio = FormatFloat("0.0%", r);
}
//---------------------------------------------------------------------------
// Doc Save / Load
//---------------------------------------------------------------------------
void TciMain::LoadDocFile()
{
   AnsiString z, tmp, file;
   int p, c=0;
   file = getCurrentDocFile();

   rcEdit->Clear();
   if (FileExists(file))
   {
      try{
      rcEdit->Lines->LoadFromFile(file);
      }catch(...){
         tmp = "Can not open file\r\n"+file;
         Application->MessageBox(tmp.c_str(),"Warning", MB_OK);
      }
   }

   if (rcEdit->Lines->Count > 0)
   {
      z = rcEdit->Lines->Strings[0];

      while ((p = z.AnsiPos("||")) > 0)
      {
         tmp = z.SubString(1, p-1);
         z.Delete(1,p+1);
         switch(c){
         case 0://Date
            dtpDate->DateTime = StrToDate(tmp); break;
         case 1://Weather
            tbnWeather->ImageIndex = StrToInt(tmp); break;
         };
         c++;
      }
      rcEdit->Lines->Delete(0);
   }
}
//---------------------------------------------------------------------------
void TciMain::SaveDocFile()
{
   AnsiString file = getCurrentDocFile();

   if (FileCanWrite(file))
   {
      AnsiString z = dtpDate->DateTime.FormatString("yyyy/mm/dd")+"||"+
                     tbnWeather->ImageIndex+"||\r\n";

      rcEdit->Text = z + rcEdit->Text;
//      rcEdit->Lines->Insert(0,z);
      rcEdit->Lines->SaveToFile(file);
      LoadDocFile();
      ShowMsg("Saved");
   }
}
//---------------------------------------------------------------------------
void TciMain::ViewInfo()
{
   Caption = "["+m_view->getFilePath()+"]";
   // Index/Total
   StatusBar1->Panels->Items[0]->Text = IntToStr(m_view->getPoint()+1) +"/"+ IntToStr(m_view->Count);
   // file name
   StatusBar1->Panels->Items[1]->Text = " "+m_view->getPicName();
   // file size
   StatusBar1->Panels->Items[2]->Text = "";
   // dpi
   StatusBar1->Panels->Items[3]->Text = IntToStr(m_view->getImgWidth()) +"x"+ IntToStr(m_view->getImgHeight());
   // ratio
   StatusBar1->Panels->Items[4]->Text = m_zPicRatio;
   // Message
   StatusBar1->Panels->Items[5]->Text = "";
}
//---------------------------------------------------------------------------
void TciMain::ShowMsg(AnsiString Msg)
{
   StatusBar1->Panels->Items[5]->Text = Msg;
}
//---------------------------------------------------------------------------
void TciMain::setStatusBarItemsWidth()
{
   StatusBar1->Panels->Items[0]->Width = Width/10;
   StatusBar1->Panels->Items[1]->Width = Width/10 *3;
   StatusBar1->Panels->Items[2]->Width = Width/10;
   StatusBar1->Panels->Items[3]->Width = Width/10 *2;
   StatusBar1->Panels->Items[4]->Width = Width/10;
   StatusBar1->Panels->Items[5]->Width = Width/10 *2;
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
// Resize
//---------------------------------------------------------------------------
void TciMain::setPicAndDocRatio()
{
   m_Ratio = (double)(pbPreview->Height)/Height;
}
//---------------------------------------------------------------------------
void __fastcall TciMain::FormResize(TObject *Sender)
{
   if (Panel1->Visible)
   {
      pbPreview->Height = Height * m_Ratio;
      if (pbPreview->Height > (Height-20))
         pbPreview->Height-=20;
      else if (pbPreview->Height < 20)
         pbPreview->Height = 20;

      setPicAndDocRatio();
   }

   LoadImage();
   setStatusBarItemsWidth();
}
//---------------------------------------------------------------------------
void __fastcall TciMain::Splitter1Moved(TObject *Sender)
{
   if (Splitter1->Top <= 0 )
   {
      Splitter1->Top = Height/2;
      Splitter1->Refresh();
   }
   setPicAndDocRatio();
   LoadImage();
}
//---------------------------------------------------------------------------

// Preview / Next / Slide Show
//---------------------------------------------------------------------------
void __fastcall TciMain::FormKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
   if (Panel1->Visible) return;

   if(Key==13)//Enter
   {
      tbnNextClick(Sender);
   }
   else if (Key==8)//backspace
   {
      tbnPreviousClick(Sender);
   }
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
void __fastcall TciMain::tbnPreviousClick(TObject *Sender)
{
   if (!m_view->Previous())
   {
      SlideShowSet(false);
   }
   LoadPicDocFile();
}
//---------------------------------------------------------------------------
void __fastcall TciMain::tbnNextClick(TObject *Sender)
{
   if (!m_view->Next())
   {
      SlideShowSet(false);
   }
   LoadPicDocFile();
}
//---------------------------------------------------------------------------
void __fastcall TciMain::ppmSlideShowClick(TObject *Sender)
{
   ppmSlideShow->Checked = !ppmSlideShow->Checked;
   SlideShowSet(ppmSlideShow->Checked);
}
//---------------------------------------------------------------------------
void __fastcall TciMain::tbnSlideShowClick(TObject *Sender)
{
   SlideShowSet(tbnSlideShow->Down);
}
//---------------------------------------------------------------------------
void TciMain::SlideShowSet(bool e)
{
   tbnSlideShow->Down = e;
   ppmSlideShow->Checked = e;
   tmrSlide->Interval = m_evm->getSlideDelay();
   tbnPrevious->Enabled = !e;
   ppmPrevious->Enabled = !e;
   tbnNext->Enabled = !e;
   ppmNext->Enabled = !e;
   tbnSaveDoc->Enabled = !e;
   tbnSavePicAs->Enabled = !e;
   ppmSavePicAs->Enabled = !e;
   tbnOption->Enabled = !e;
   tbnReloadFiles->Enabled = !e;
   btnDelete->Enabled = !e;
   btnVisibleDoc->Enabled = !e;
   tmrSlide->Enabled = e;
}
//---------------------------------------------------------------------------
void __fastcall TciMain::tmrSlideTimer(TObject *Sender)
{
   switch (m_evm->getSeguenceType()){
   case m_cst.Forward:  tbnNextClick(Sender); break;
   case m_cst.Reverse:  tbnPreviousClick(Sender); break;
   };
}
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
// RichBox Function
//---------------------------------------------------------------------------
void __fastcall TciMain::tbnBoldClick(TObject *Sender)
{//
   if (rcEdit->SelAttributes->Style == rcEdit->SelAttributes->Style << fsBold )
      rcEdit->SelAttributes->Style = rcEdit->SelAttributes->Style >> fsBold;
   else
      rcEdit->SelAttributes->Style = rcEdit->SelAttributes->Style << fsBold;
}
//---------------------------------------------------------------------------
void __fastcall TciMain::tbnItalicClick(TObject *Sender)
{//
   if (rcEdit->SelAttributes->Style == rcEdit->SelAttributes->Style << fsItalic )
      rcEdit->SelAttributes->Style = rcEdit->SelAttributes->Style >> fsItalic;
   else
      rcEdit->SelAttributes->Style = rcEdit->SelAttributes->Style << fsItalic;
}
//---------------------------------------------------------------------------
void __fastcall TciMain::tbnUnderlineClick(TObject *Sender)
{//
   if (rcEdit->SelAttributes->Style == rcEdit->SelAttributes->Style << fsUnderline )
      rcEdit->SelAttributes->Style = rcEdit->SelAttributes->Style >> fsUnderline;
   else
      rcEdit->SelAttributes->Style = rcEdit->SelAttributes->Style << fsUnderline;
}
//---------------------------------------------------------------------------
void __fastcall TciMain::cboFontChange(TObject *Sender)
{//
   rcEdit->SelAttributes->Name = cboFont->Text;
}
//---------------------------------------------------------------------------
void __fastcall TciMain::tbnFontColorClick(TObject *Sender)
{
   rcEdit->SelAttributes->Color = m_SelColor;
}
//---------------------------------------------------------------------------
void __fastcall TciMain::btnSelColorClick(TObject *Sender)
{
   Application->CreateForm(__classid(TciColorSelView), &ciColorSelView);
   ciColorSelView->Top = Top + btnSelColor->Height+ CoolBar1->Height+ pbPreview->Height;
   ciColorSelView->Left = Left+ btnSelColor->Left+ tbrEditer->Left;

   if (ciColorSelView->ShowModal()==mrOk)
   {
      ciColorSelView->CreateSelColorToImageList(3, imgEdit);
      m_SelColor = ciColorSelView->getSelColor();
      rcEdit->SelAttributes->Color = m_SelColor;
   }
   ciColorSelView->Release();
}
//---------------------------------------------------------------------------
void __fastcall TciMain::cboSizeChange(TObject *Sender)
{//
   if ( rcEdit->SelLength > 0 )
   {
      try{
         rcEdit->SelAttributes->Size = StrToInt(cboSize->Text);
      }catch(...)
      {
         cboSize->Text = "10";
      }
   }
}
//---------------------------------------------------------------------------
void __fastcall TciMain::tbnCutClick(TObject *Sender)
{
   rcEdit->CutToClipboard();
}
//---------------------------------------------------------------------------
void __fastcall TciMain::tbnCopyClick(TObject *Sender)
{
   rcEdit->CopyToClipboard();
}
//---------------------------------------------------------------------------
void __fastcall TciMain::tbnPasteClick(TObject *Sender)
{
   rcEdit->PasteFromClipboard();
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
void __fastcall TciMain::tbnWeatherClick(TObject *Sender)
{
   if (tbnWeather->ImageIndex<2)
      tbnWeather->ImageIndex++;
   else
      tbnWeather->ImageIndex = 0;

   switch(tbnWeather->ImageIndex){
   case 0: tbnWeather->Hint = "Sun"; break;
   case 1: tbnWeather->Hint = "Overcast"; break;
   case 2: tbnWeather->Hint = "Rain"; break;
   }
}
//---------------------------------------------------------------------------



// File Write
//---------------------------------------------------------------------------
bool TciMain::FileCanWrite(AnsiString file)
{
   bool Write;
   if (file=="" || file==NULL)
     Write = false;
   else if (FileExists(file))
   {
      if (Application->MessageBox("File exists! Want to rewrite?","Warning", MB_ICONWARNING+MB_YESNO+MB_DEFBUTTON2)==ID_YES)
      {
         Write = true;
      }
      else
         Write = false;
   }
   else
      Write = true;

   return Write;
}
//---------------------------------------------------------------------------
void __fastcall TciMain::tbnSavePicAsClick(TObject *Sender)
{
 //  bool bSave = true;
   char szFileName[MAXFILE+4];
   SaveDialog1->FileName = ExtractFileName(m_view->getPicName());
   SaveDialog1->Filter = ExtractFileExt(m_view->getPicName());

   if (SaveDialog1->FileName == "" || SaveDialog1->FileName==NULL) return;
   if (SaveDialog1->Execute())
   {
      if(FileCanWrite(SaveDialog1->FileName))
      {
      fnsplit(SaveDialog1->FileName.c_str(), 0, 0, szFileName, 0);
      strcat(szFileName, ".BAK");
      RenameFile(SaveDialog1->FileName, szFileName);

      Image->Picture->SaveToFile(SaveDialog1->FileName);
      }
   }
}
//---------------------------------------------------------------------------

void __fastcall TciMain::tbnSaveDocClick(TObject *Sender)
{
   SaveDocFile();
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
// Scan Dir
void __fastcall TciMain::tbnScanDirClick(TObject *Sender)
{
   Application->CreateForm(__classid(TciFolderSelectView), &ciFolderSelectView);

   ciFolderSelectView->setSelectedFolder(m_view->getScanDirectory());

   if (ciFolderSelectView->ShowModal() == mrOk)
   {
      m_view->setScanDirectory(ciFolderSelectView->getSelectedFolder());
      Caption = "["+m_view->getScanDirectory()+"]";
   }
   ciFolderSelectView->Release();
}
//---------------------------------------------------------------------------
// Reload Files
void __fastcall TciMain::tbnReloadFilesClick(TObject *Sender)
{
   ShowMsg("Scaning");
   pbPreview->Cursor = crHourGlass;
   tbnReloadFiles->Enabled = false;
   
   m_view->ScanDirectoryFiles();

   pbPreview->Cursor = crArrow;
   tbnReloadFiles->Enabled = true;
   LoadPicDocFile();
   ShowMsg("Scaned");
}
//---------------------------------------------------------------------------
// Delete
void __fastcall TciMain::btnDeleteClick(TObject *Sender)
{
   if (m_view->Count <= 0) return;

   AnsiString file = getCurrentPicFile();
   AnsiString doc = getCurrentDocFile();
   if (Application->MessageBox("Are you sure want to delete this file(s)?", "Warning", MB_ICONWARNING+MB_YESNO+MB_DEFBUTTON2) == ID_YES)
   {
      if(FileExists(file))
      {
         DeleteFile(file);
         m_view->Delete(m_view->getPoint());
      }
      if(FileExists(doc)) DeleteFile(doc);
      tbnReloadFilesClick(Sender);
      LoadPicDocFile();
      ShowMsg("Deleted");
   }
}
//---------------------------------------------------------------------------
// Visible Doc
void __fastcall TciMain::btnVisibleDocClick(TObject *Sender)
{
   Panel1->Visible = !Panel1->Visible;
   Splitter1->Visible = Panel1->Visible;
   Splitter1->Top = Top +pbPreview->Height;
   Panel1->Top = Splitter1->Top+ Splitter1->Height;
   ppmVisableDoc->Checked = Panel1->Visible;

   if (!Panel1->Visible)
   {
       m_nSaveHeight = pbPreview->Height;
       pbPreview->Height = Height;
   }
   else
   {
       pbPreview->Height = m_nSaveHeight;
   }
   LoadImage();
}
//---------------------------------------------------------------------------
// Option
void __fastcall TciMain::tbnOptionClick(TObject *Sender)
{
   ciOptionView->setEnvironment(m_evm);
   ciOptionView->ShowModal();
   m_view->setRepeat(m_evm->getRepeat());
}
//---------------------------------------------------------------------------
// About
void __fastcall TciMain::btnAboutClick(TObject *Sender)
{
   ciAboutView->Show();
}
//---------------------------------------------------------------------------
void __fastcall TciMain::dtpDateChange(TObject *Sender)
{
   AnsiString week;
   switch(dtpDate->DateTime.DayOfWeek()) {
   case 1: week="Sun"; break; case 2: week="Mon"; break; case 3: week="Tus"; break;
   case 4: week="Wed"; break; case 5: week="Thu"; break; case 6: week="Fri"; break;
   case 7: week="Sat"; break;};
   lbDayOfWeek->Caption = "  "+week+"  ";
}
//---------------------------------------------------------------------------

