//---------------------------------------------------------------------------

#ifndef frmMainH
#define frmMainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <jpeg.hpp>
#include <ToolWin.hpp>
#include <Dialogs.hpp>
#include <Menus.hpp>
#include <ImgList.hpp>
//---------------------------------------------------------------------------
#include <io.h>
#include <dos.h>
#include <dirent.h>
#include <dir.h>
//---------------------------------------------------------------------------
#include "caEnvironment.h"
#include "caConst.h"
#include "frmColorSelView.h"
#include "frmOption.h"
#include "frmAbout_like_ICQ.h"
#include "caView.h"
#include "frmFolderSelectView.h"
//---------------------------------------------------------------------------
class TciMain : public TForm
{
__published:	// IDE-managed Components
        TColorDialog *ColorDialog1;
    TPanel *Panel1;
    TSplitter *Splitter1;
    TCoolBar *CoolBar1;
    TToolBar *tbrViewer;
        TToolButton *tbnPrevious;
        TToolButton *tbnNext;
    TToolBar *tbrEditer;
    TComboBox *cboFont;
    TComboBox *cboSize;
    TToolButton *ToolButton9;
        TToolButton *tbnBold;
        TToolButton *tbnItalic;
        TToolButton *tbnUnderline;
        TImageList *imgEdit;
    TToolBar *tbrTool;
        TToolButton *tbnReloadFiles;
        TToolButton *tbnOption;
    TToolButton *ToolButton1;
        TToolButton *tbnCut;
        TToolButton *tbnCopy;
        TToolButton *tbnPaste;
        TImageList *imgWeather;
        TImageList *imgViewer;
        TToolButton *tbnFontColor;
        TImageList *imgTool;
        TRichEdit *rcEdit;
        TToolButton *ToolButton4;
        TToolButton *tbnSavePicAs;
        TToolButton *tbnSlideShow;
        TSaveDialog *SaveDialog1;
        TToolButton *tbnSaveDoc;
        TToolButton *ToolButton5;
        TTimer *tmrSlide;
        TButton *btnSelColor;
        TPaintBox *pbPreview;
        TImage *Image;
        TPopupMenu *PopupMenu1;
        TMenuItem *ppmPrevious;
        TMenuItem *ppmNext;
        TMenuItem *ppmSlideShow;
        TMenuItem *N1;
        TMenuItem *ppmSavePicAs;
        TMenuItem *N2;
        TMenuItem *ppmVisableDoc;
        TToolButton *btnVisibleDoc;
        TToolButton *btnAbout;
        TToolButton *btnDelete;
        TToolButton *ToolButton2;
        TStatusBar *StatusBar1;
        TToolButton *tbnScanDir;
        TToolBar *tbrInfo;
        TLabel *Label1;
        TDateTimePicker *dtpDate;
        TLabel *lbDayOfWeek;
        TToolButton *tbnWeather;
        TToolButton *ToolButton3;
        void __fastcall FormCreate(TObject *Sender);
        void __fastcall FormDestroy(TObject *Sender);
    void __fastcall Splitter1Moved(TObject *Sender);
        void __fastcall tbnBoldClick(TObject *Sender);
        void __fastcall tbnItalicClick(TObject *Sender);
        void __fastcall tbnUnderlineClick(TObject *Sender);
        void __fastcall cboFontChange(TObject *Sender);
        void __fastcall cboSizeChange(TObject *Sender);
        void __fastcall tbnWeatherClick(TObject *Sender);
        void __fastcall FormShow(TObject *Sender);
        void __fastcall tbnPreviousClick(TObject *Sender);
        void __fastcall tbnNextClick(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall FormKeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
        void __fastcall tbnSavePicAsClick(TObject *Sender);
        void __fastcall tbnReloadFilesClick(TObject *Sender);
        void __fastcall tbnSaveDocClick(TObject *Sender);
        void __fastcall tmrSlideTimer(TObject *Sender);
        void __fastcall tbnSlideShowClick(TObject *Sender);
        void __fastcall btnSelColorClick(TObject *Sender);
        void __fastcall tbnFontColorClick(TObject *Sender);
        void __fastcall FormResize(TObject *Sender);
        void __fastcall btnVisibleDocClick(TObject *Sender);
        void __fastcall ppmSlideShowClick(TObject *Sender);
        void __fastcall tbnOptionClick(TObject *Sender);
        void __fastcall tbnCutClick(TObject *Sender);
        void __fastcall tbnCopyClick(TObject *Sender);
        void __fastcall tbnPasteClick(TObject *Sender);
        void __fastcall btnAboutClick(TObject *Sender);
        void __fastcall btnDeleteClick(TObject *Sender);
        void __fastcall tbnScanDirClick(TObject *Sender);
        void __fastcall dtpDateChange(TObject *Sender);
private:	// User declarations
        TView *m_view;

        TEnvironment *m_evm;
        TColor m_SelColor;
        double m_Ratio;
        AnsiString m_zPicRatio;
        int m_nSaveHeight;
        TConst  m_cst;

        AnsiString getCurrentPicFile();
        AnsiString getCurrentDocFile();

        void Init();
        void LoadPicDocFile();
	void LoadImage();
	void UpdatePreviewImage();
        void LoadDocFile();
        void SaveDocFile();
        void ViewInfo();
        void ShowMsg(AnsiString Msg);
        void setStatusBarItemsWidth();
        void SlideShowSet(bool);
        bool FileCanWrite(AnsiString);
        void setPicAndDocRatio();
public:		// User declarations
        __fastcall TciMain(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TciMain *ciMain;
//---------------------------------------------------------------------------
#endif
