//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "caEnvironment.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)

//---------------------------------------------------------------------------
__fastcall TEnvironment::TEnvironment()
{
   m_zIniFile = ChangeFileExt(Application->ExeName, ".ini");
   m_ScanFilter = new TScanFilter();
   Load();
}
//---------------------------------------------------------------------------
__fastcall TEnvironment::~TEnvironment()
{
   Save();
   delete m_ScanFilter;
}
//---------------------------------------------------------------------------
void TEnvironment::Load()
{
   TIniFile *ini = new TIniFile(m_zIniFile);

   m_nFormTop = ini->ReadInteger("Form", "Top", 150);
   m_nFormLeft = ini->ReadInteger("Form", "Left", 300);
   m_nFormHeight = ini->ReadInteger("Form", "Height", 700);
   m_nFormWidth = ini->ReadInteger("Form", "Width", 686);
   m_nPreviewHeight = ini->ReadInteger("Form", "PreviewHeight", 400);
   m_bDocVisible = ini->ReadBool("Form","DocVisible", true);
//   m_nSplitterTop = ini->ReadInteger("Form", "SplitterTop", 400);

   m_zScanPath = ini->ReadString("View", "ScanPath", ExtractFileDir(Application->ExeName));
   if (!DirectoryExists(m_zScanPath))
   {
      m_zScanPath = ExtractFileDir(Application->ExeName);
   }

   m_nSlideDelay = ini->ReadInteger("View", "SlideDelay", 3000);
   m_nSeguenceType = ini->ReadInteger("View", "SeguenceType", 1);
   m_bSaveIndex = ini->ReadBool("View", "SaveIndex", true);
   if (m_bSaveIndex)
      m_nSavePicIndex = ini->ReadInteger("View", "PicIndex", -1);
   else
      m_nSavePicIndex = -1;
   if ( m_nSeguenceType < 1 || m_nSeguenceType > 2 ) m_nSeguenceType = 1;
   m_bRepeat = ini->ReadBool("View", "Repeat", false);
   /*
   m_bFilterJPG = ini->ReadBool("View", "Filter JPG", true);
   m_bFilterBMP = ini->ReadBool("View", "Filter BMP", false);
   */
   m_ScanFilter->setJPG(ini->ReadBool("File Filter", "JPG", true));
   m_ScanFilter->setBMP(ini->ReadBool("File Filter", "BMP", false));
   delete ini;
}
//---------------------------------------------------------------------------
void TEnvironment::Save()
{
   TIniFile *ini = new TIniFile(m_zIniFile);

   ini->WriteInteger("Form", "Top", m_nFormTop);
   ini->WriteInteger("Form", "Left", m_nFormLeft);
   ini->WriteInteger("Form", "Height", m_nFormHeight);
   ini->WriteInteger("Form", "Width", m_nFormWidth);
//   ini->WriteInteger("Form", "SplitterTop", m_nSplitterTop);
   ini->WriteInteger("Form", "PreviewHeight", m_nPreviewHeight);
   ini->WriteBool("Form","DocVisible", m_bDocVisible);
   ini->WriteString("View", "ScanPath", m_zScanPath);
   ini->WriteInteger("View", "SlideDelay", m_nSlideDelay);
   ini->WriteInteger("View", "SeguenceType", m_nSeguenceType);
   if (!m_bSaveIndex) m_nSavePicIndex = -1;
   ini->WriteBool("View", "SaveIndex", m_bSaveIndex);
   ini->WriteInteger("View", "PicIndex", m_nSavePicIndex);
   ini->WriteBool("View", "Repeat", m_bRepeat);
   /*
   ini->WriteBool("View", "Filter JPG", m_bFilterJPG);
   ini->WriteBool("View", "Filter BMP", m_bFilterBMP);
   */
   ini->WriteBool("File Filter", "JPG", m_ScanFilter->getJPG());
   ini->WriteBool("File Filter", "BMP", m_ScanFilter->getBMP());
   delete ini;
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
int TEnvironment::getFormTop()
{
   return m_nFormTop;
}
void TEnvironment::setFormTop(int FormTop)
{
   m_nFormTop = FormTop;
}
//---------------------------------------------------------------------------
int TEnvironment::getFormLeft()
{
   return m_nFormLeft;
}
void TEnvironment::setFormLeft(int FormLeft)
{
   m_nFormLeft = FormLeft;
}
//---------------------------------------------------------------------------
int TEnvironment::getFormHeight()
{
   return m_nFormHeight;
}
void TEnvironment::setFormHeight(int FormHeight)
{
   m_nFormHeight = FormHeight;
}
//---------------------------------------------------------------------------
int TEnvironment::getFormWidth()
{
   return m_nFormWidth;
}
void TEnvironment::setFormWidth(int FormWidth)
{
   m_nFormWidth = FormWidth;
}
//---------------------------------------------------------------------------
/*
int TEnvironment::getSplitterTop()
{
   return m_nSplitterTop;
}
void TEnvironment::setSplitterTop(int SplitterTop)
{
   m_nSplitterTop = SplitterTop;
}
//---------------------------------------------------------------------------
*/
int TEnvironment::getPreviewHeight()
{
   return m_nPreviewHeight;
}
void TEnvironment::setPreviewHeight(int PreviewHeight)
{
   m_nPreviewHeight = PreviewHeight;
}
//---------------------------------------------------------------------------
bool TEnvironment::getDocVisible()
{
   return m_bDocVisible;
}
void TEnvironment::setDocVisible(bool DocVisible)
{
   m_bDocVisible = DocVisible;
}
//---------------------------------------------------------------------------
int TEnvironment::getSavePicIndex()
{
   return m_nSavePicIndex;
}
void TEnvironment::setSavePicIndex(int SavePicIndex)
{
   m_nSavePicIndex = SavePicIndex;
}
//---------------------------------------------------------------------------
AnsiString TEnvironment::getScanPath()
{
   return m_zScanPath;
}
void TEnvironment::setScanPath(AnsiString ScanPath)
{
   m_zScanPath = ScanPath;
}
//---------------------------------------------------------------------------
int TEnvironment::getSlideDelay()
{
   return m_nSlideDelay;
}
void TEnvironment::setSlideDelay(int SlideDelay)
{
   m_nSlideDelay = SlideDelay;
}
//---------------------------------------------------------------------------
int TEnvironment::getSeguenceType()
{
   return m_nSeguenceType;
}
void TEnvironment::setSeguenceType(int SeguenceType)
{
   m_nSeguenceType = SeguenceType;
}
//---------------------------------------------------------------------------
bool TEnvironment::getSaveIndex()
{
   return m_bSaveIndex;
}
void TEnvironment::setSaveIndex(bool SaveIndex)
{
   m_bSaveIndex = SaveIndex;
}
//---------------------------------------------------------------------------
bool TEnvironment::getRepeat()
{
   return m_bRepeat;
}
void TEnvironment::setRepeat(bool Repeat)
{
   m_bRepeat = Repeat;
}
//---------------------------------------------------------------------------
/*
bool TEnvironment::getFilterJPG()
{
   return m_bFilterJPG;
}
void TEnvironment::setFilterJPG(bool FilterJPG)
{
   m_bFilterJPG = FilterJPG;
}
//---------------------------------------------------------------------------
bool TEnvironment::getFilterBMP()
{
   return m_bFilterBMP;
}
void TEnvironment::setFilterBMP(bool FilterBMP)
{
   m_bFilterBMP = FilterBMP;
}
//--------------------------------------------------------------------------
*/
TScanFilter *TEnvironment::getScanFilter()
{
   return m_ScanFilter;
}
void TEnvironment::setScanFilter(TScanFilter *ScanFilter)
{
   m_ScanFilter = ScanFilter;
}
//---------------------------------------------------------------------------

