//---------------------------------------------------------------------------

#ifndef caViewH
#define caViewH
//---------------------------------------------------------------------------
#include <io.h>
#include <dirent.h>
#include <dir.h>
//---------------------------------------------------------------------------
#include "caScanFilter.h"
//---------------------------------------------------------------------------
class TView : public TStringList
{
private:
   int m_nPoint;
   AnsiString m_zAppDir;
   AnsiString m_zScanDirectory;
   TScanFilter *m_ScanFilter;
   int m_nImgHeight;
   int m_nImgWidth;
   float m_fImgRatio;
   bool m_bRepeat;

   void ScanDirectoryFiles(char *dirname);
public:
   __fastcall TView();
   virtual __fastcall ~TView();

   int getPoint();
   void setPoint(int Point);
   bool CheckPoint();
   bool Previous();
   bool Next();
   bool getRepeat();
   void setRepeat(bool Repeat);
   void LoadFilesFromFile();
   void SaveFilesToFile();
   AnsiString getScanDirectory();
   void setScanDirectory(AnsiString ScanDirectory);
   void ScanDirectoryFiles();
   TScanFilter *getScanFilter();
   void setScanFilter(TScanFilter *ScanFilter);
   AnsiString getFilePath();
   AnsiString getPicName();
   AnsiString getDocName();
   int getImgHeight();
   void setImgHeight(int ImgHeight);
   int getImgWidth();
   void setImgWidth(int ImgWidth);
   float getImgRatio(int RealHeight, int RealWidth);
   void setImgRatio(float ImgRatio);
};
//---------------------------------------------------------------------------
extern PACKAGE TView *caView;
//---------------------------------------------------------------------------
#endif